﻿using System.Reflection;
using HarmonyLib;
using UnityEngine;

namespace pp.RaftMods.BowRelease
{
    public class CBowRelease : Mod
    {
        public const string VERSION     = "1.0.0";
        public const string APP_IDENT   = "pp.RaftMods.BowRelease";

        private static Harmony mi_harmony;
        private static bool m_abortThrow;

        private void Awake()
        {
            mi_harmony = new Harmony(APP_IDENT);
            mi_harmony.PatchAll(Assembly.GetExecutingAssembly());
        }

        private void Update()
        {
            if (RAPI.IsCurrentSceneGame())
            {
                m_abortThrow = Input.GetKey(KeyCode.Mouse1);
            }
        }

        [HarmonyPatch(typeof(ThrowableComponent), "HandleReleaseButton")]
        public class HarmonyPatch_HandleReleaseButton
        {
            [HarmonyPrefix]
            private static bool HandleReleaseButton(ThrowableComponent __instance)
            {
                return !m_abortThrow;
            }
        }
    }
}